﻿using System;
using System.Collections.Generic;

using System.Data.Linq.Mapping;
using DbLinq.Data.Linq;
using DbLinq.Sqlite;
using System.Text;  
using System.Data.SQLite;

namespace HeuristicLab.Modeling.SQLiteBackend {
  public class ModelingDataContext : SqliteDataContext {

    public static string connectionString;

    public ModelingDataContext() : this(connectionString) {      
    }

    public ModelingDataContext(string connection)
      : base(new SQLiteConnection(connection)) {
    }

    #region Tables
    public Table<Algorithm> Algorithms {
      get { return GetTable<Algorithm>(); }
    }

    public Table<Variable> Variables {
      get { return GetTable<Variable>(); }
    }

    public Table<Problem> Problems {
      get { return GetTable<Problem>(); }
    }

    public Table<Result> Results {
      get { return GetTable<Result>(); }
    }

    public Table<Model> Models {
      get { return GetTable<Model>(); }
    }


    public Table<InputVariableResult> InputVariableResults {
      get { return GetTable<InputVariableResult>(); }
    }

    public Table<ModelResult> ModelResults {
      get { return GetTable<ModelResult>(); }
    }

    public Table<InputVariable> InputVariables {
      get { return GetTable<InputVariable>(); }
    }
    #endregion
  }
}
